# Life

*Life is the greatest miracle of our Universe.*

The definition of *life* depends on context and particular field of study and is typically very broad and [fuzzy](fuzzy.md), but generally speaking it's a form of very complex behavior similar to that of humans, often characterized by attributes such as reproduction, thinking, emotion, reacting to stimuli, growing, communication, [consciousness](consciousness.md), self preservation instincts etc. This separates matter to living (animals, humans, plants, ...) and non-living ([rocks](rock.md), water, ...), we say something is either alive of [dead](death.md). It's hard to isolate an exact set of attributes identifying life because whenever we think of an attribute as a necessity for life, we can subsequently break the definition by imagining something without said attribute that would still be perceived as living: for example should we naturally assume reproduction a necessary attribute of life, we can immediately think of a sterile individual incapable of reproduction who is nonetheless still quite clearly a living being. Therefore we tend to classify life by fuzzy [clustering](cluster.md), in terms of "[closeness](distance.md)" to what we typically expect a living being to look like (and this closeness, i.e. distance, may give rise to a spectrum, implying some things may be "more alive" than others, as in "humans are more alive than viruses"), and this in turn comes with borderline cases where we remain unsure, such as [artificial intelligence](ai.md). Some have alternatively defined life as **that which resists [entropy](entropy.md)**, i.e. systems that maintain their own ordered structure in spite of natural laws constantly working towards everything "turning to dust", and that would be an excellent definition wasn't it for the fact that some just can't find it satisfactory: for example most religions or biologists can't accept it as even robots are hereby classified as living beings. Biologists may define life as carbon-based matter exhibiting certain biological processes. Religions often connect life with "soul", a supernatural essence present in humans, animals and perhaps even plants. For the purposes of [our](lrs.md) wiki we will define life as that which **by its behavior, especially showing experience of pleasure and suffering, is similar to us, humans**. For us life is the greatest miracle in our [Universe](universe.md) and we choose to [make it our goal](less_retarded_society.md) to support it, make it thrive and be happy.

Life and circumstances of life, such as its origin, mechanisms, purpose and abundance in the Universe, belong among the greatest mysteries in existence. After thousands of years science can't give us answers -- not even remote guesses. [Earth](earth.md) is so far the only place in [Universe](universe.md) known to ever have hosted life -- despite best efforts we never came across a compelling evidence or even a hint of alien life anywhere besides our home planet. But it's still possible that life is all around us, just staying hidden -- does an ant crawling on human's shoe realize he's touching a giant living being? Origin of life itself remains unanswered as well. Some believe it may have been brought to Earth from different parts of the Universe, e.g. by comets -- the so called *panspermia* theory. Most prevalent is however the theory that life arose itself [by chance](randomness.md) from non-living matter, which is called *abiogenesis*. But, again, we don't have a slightest clue about how likely it is for life to randomly come to be on its own, scientists never came close to replicating such process in their laboratories. Religions are typically built upon a belief that life was created by [god](god.md) or another kind of supernatural entity. Most of what we know from scientific point of view can probably be summed up like this: life is based on the the chemical element carbon, it probably needs water in liquid state, in its most primitive form it appeared on Earth nearly 4 billion years ago and then continued to slowly change over time according to Darwin's laws of [evolution](evolution.md) and natural selection and the genetic information of living organisms is carried (mostly) by the [DNA](dna.md) molecule.

TODO

It is [currently](21st_century.md) better to be dead than alive. [LRS](lrs.md) is trying to change this but it will fail.

{ My current experience as a living being is that life is worse than death -- life in itself could be good but the environment doesn't allow this, it would be very good to have life in an environment that allowed for happiness of life, I would call that a paradise. Now I already also know it's impossible to make such environment but the only good thing to do is still strive for it, even knowing one will fail, doing anything else is just worse. So I will try to achieve this, then I will fail and die and I will be in peace. ~drummyfish }

Life is a constant change for the worse.

The end goal of a life form is to free itself from the slavery of [competition](competition.md) -- achieving this is the goal of our [less retarded society](less_retarded_society.md).

## See Also

- [game of life](game_of_life.md)